/*
 * Copyright 2010 Trustees of the University of Pennsylvania Licensed under the
 * Educational Community License, Version 2.0 (the "License"); you may
 * not use this file except in compliance with the License. You may
 * obtain a copy of the License at
 *
 * http://www.osedu.org/licenses/ECL-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS"
 * BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing
 * permissions and limitations under the License.
 */
package metridoc.sushi

import java.io.InputStream;

import org.apache.http.HttpResponse;
import org.apache.http.auth.AuthScope;
import org.apache.http.auth.UsernamePasswordCredentials;
import org.apache.http.client.ResponseHandler;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.DefaultHttpClient;

/**
 * Created by IntelliJ IDEA.
 * User: tbarker
 * Date: 5/10/11
 * Time: 3:19 PM
 * To change this template use File | Settings | File Templates.
 */
class SushiRunner {
    def Object execute(SushiTemplate template, ResponseHandler responseHandler) {
		def client = new DefaultHttpClient()
		def post = new HttpPost(template.sushiUrl)
		post.entity = new StringEntity(template.soap, "text/xml", "utf-8")
		post.setHeader("SOAPAction", template.soapAction)

		if (template.basicUsername && template.basicPassword) {
			client.getCredentialsProvider().setCredentials(
				AuthScope.ANY,
				new UsernamePasswordCredentials(template.basicUsername, template.basicPassword));
		}

		return client.execute(post, responseHandler)
    }
}

